#pragma once
//*****************************************************************************************************
//  1. t@C
//		ManualEditView.h
//----------------------------------------------------------------------------------------------------
//  2. @\
//		CManualEditView NX̃C^[tFCX
//----------------------------------------------------------------------------------------------------
//  3. l
//----------------------------------------------------------------------------------------------------
//  4. 
//		2006.09.01 S.Aizawa(xxx) VK쐬
//*****************************************************************************************************

#include "ManualEditChildWnd.h"
#include "ManualEditDocument.h"
#include "ManualEditSublineInfo.h"

// ƍWf[^
#define COORDINATE_KIND_SAGYO			0
#define COORDINATE_KIND_JIDO			1
#define COORDINATE_KIND_HANJIDO			2
#define COORDINATE_KIND_JIDO_KYOTSU		3
#define COORDINATE_KIND_HANJIDO_KYOTSU	4
#define COORDINATE_KIND_KYOTSU_KOTEI	5

// TuCʍWf[^
struct SZahyoSubline {
	int nSublineId;				// TuCID
	int nLeft;					// [
	int nRight;					// E[
	CManualEditSublineInfo cSublineInfo; 
};
typedef CArrayEx <SZahyoSubline, SZahyoSubline&> CZahyoSublineArray;

// LbgTuC؂Wf[^
struct SZahyoKittingSubline {
	CPoint pointLine;
	CString sSiblineName1;
	CString sSiblineName2;
};
typedef CArrayEx <SZahyoKittingSubline, SZahyoKittingSubline&> CZahyoKittingSublineArray;

// Ot\Wf[^
struct SZahyoGraph {
	CRect rect;					// W
	CString sText;				// \eLXg
	int nKind;					// \
	int nKishuId;
};
typedef CArrayEx <SZahyoGraph, SZahyoGraph&> CZahyoGraphArray;

// ʍHg̍W
struct SZahyoKyotsuKoteiFrame {
	CRect rect;
};
typedef CArrayEx <SZahyoKyotsuKoteiFrame, SZahyoKyotsuKoteiFrame&> CZahyoKyotsuKoteiFrameArray;

// 蓮Ґʃr[
class CManualEditView : public CScrollView
{
protected:
	CManualEditView();           // IɎgpveNg RXgN^B
	DECLARE_DYNCREATE(CManualEditView)

// Agr[g
public:

// Iy[V
public:

// I[o[Ch
	// ClassWizard ͉z֐̃I[o[Ch𐶐܂B
	//{{AFX_VIRTUAL(CManualEditView)
	protected:
	virtual void OnInitialUpdate();     // \zAŏ̏B
	virtual void OnDraw(CDC* pDC);
	//}}AFX_VIRTUAL

// Cve[V
protected:

	// ꂽbZ[W }bv֐
	//{{AFX_MSG(CManualEditView)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	afx_msg void OnGetToolTipText(NMHDR* pNMH, LRESULT* pRes);
	DECLARE_MESSAGE_MAP()

protected:
	int m_nLeftMargin;			// }[W
	int m_nTopMargin;			// }[W
	int m_nRightMargin;			// E}[W
	int m_nBottomMargin;		// }[W
	int m_nBarWidth;			// o[̕
	int m_nLeftSpacing;			// cƈԍ̃o[̊Ԃ̃Xy[X
	int m_nBarSpacing;			// o[Ԃ̃Xy[X
	int m_moveHight;			// Ґʂ̏cړ 20040214 xxxxx kuwa
	CZahyoSublineArray m_aZahyoSubline;	// TuCʍWf[^
	CZahyoGraphArray m_aZahyoGraph;	// Ot\Wf[^
	CZahyoKittingSublineArray m_aZahyoKittingSubline;	// LbgTuC؂Wf[^
	CZahyoKyotsuKoteiFrameArray m_aZahyoKyotsuKoteiFrame;	// ʍHWf[^
	CZahyoSagyoshaArray m_aZahyoSagyosha;
	CRect m_rectView;			// r[Ŝ̑傫
	CRect m_rectGraph;			// Ot̑傫
	CPen m_penGraph;			// Ot`p̃y
	CPen m_penAxis;				// `p̃y
	CPen m_penTact;				// ڕW^Ng`p̃y
	CPen m_penTactLimit;		// ڕW^Ng̏㉺`p̃y
	CPen m_penSublineBar;		// TuCԋ؂p̃y
	CPen m_penKyotsuKotei;		// ʍH`p̃y
	CPen m_penKittingLine;		// TuCELbgCԋ؂`p̃y
	CPen m_penKittingSubline;	// LbgƃTuCԋ؂`p̃y
	CFont m_fontGraph;			// `ptHg
	CFont m_fontH;				// `ptHg
	CFont m_fontV;				// c`ptHg
	CFont m_fontTime;			// Ǝԕ`ptHg
	CBrush m_brushJido;			// H`puV
	CBrush m_brushHanJido;		// H`puV
	CBrush m_brushKyotsuJido;		// HiʍHj`puV
	CBrush m_brushKyotsuHanJido;	// HiʍHj`puV
	CBrush m_brushGraph[MAX_KISHU];	// @ʂ̃o[`puV
	CBitmap m_bmpKyotsuKotei;	// ʍH}[Ñrbg}bv
	CDC m_dcCompatible;			// ʍH}[N`pDC
	BOOL m_bInitialize;			// ς݃tO
	int m_nGraphSublineNum;		// Ot\TuC̐
	CSize m_sizeKyotsuKotei;	// ʍH}[ÑTCY
	double m_fScaleFactor;		// P̃sNZ

	CManualEditDocument *GetDocument() { return (CManualEditDocument *)CView::GetDocument(); }
	void InitializeZahyoData();
	void ClearZahyoData();
	void AddZahyoGraph(const CRect &rect, CString &sText, int nKind, int nKishuId = 0);
	int AddKyotsuKoteiFrame(const CRect &rect);
	void AddZahyoSagyosha(const CRect &rect, int nSublineId, int nSagyoshaId);
	SZahyoSagyosha *CheckZahyoSagyosha(CPoint point);
	void DrawGraph(CDC *pDC, BOOL bDrawText);
	void DrawKyotsuKoteiFrame(CDC *pDC);
	void DrawVerticalAxisLine(CDC *pDC);
	void DrawHorizontalAxisLine(CDC *pDC);
	void DrawTactLine(CDC *pDC);
	void DrawVerticalAxisText(CDC *pDC, LPCTSTR pText);
	void DrawLegends(CDC *pDC);
	void DrawLeftTriangle(CDC *pDC, const CRect &rect);
	void DrawRightTriangle(CDC *pDC, const CRect &rect);
	void DrawTextCenter(CDC *pDC, const CString &sText, CRect rect);
	void DrawTime(CDC *pDC, SGraphSubline &cGraphSubline, int nLeft, double fTime);
	void DrawSublineBoundLine(CDC *pDC);
	void DrawKittingSubline(CDC *pDC);
	int OnToolHitTest(CPoint point, TOOLINFO * pTI) const;
	void SetScaleFactor(BOOL bAdjust, int nKishuId);
	double GetMaxTime(int nKishuId);
	void SetSlimMode();
	void SetSlim(int &nScale);
	int GetTotalSagyoshaNum();
	int GetKittingSagyoshaNum();
	void DispSublineInfo();
	void SetSublineInfoPos();
	void SetSublineInfoPos2();
	void HideSublineInfo();
	int GetScaleHeight(double fMinute);
	void DispCenterSagyosha(int nSublineId, int nSagyoshaId);
	SZahyoSubline *GetZahyoSubline(CPoint point);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ ͑Os̒Oɒǉ̐錾}܂B
